/// <reference types="node" />
import { IGherkinOptions } from './types';
import { Readable } from 'stream';
import ParserMessageStream from './stream/ParserMessageStream';
import { messages } from 'cucumber-messages';
import Dialect from './Dialect';
import { uuid, incrementing } from './IdGenerator';
export declare function fromStream(stream: Readable, options?: IGherkinOptions): ParserMessageStream;
export declare function fromPaths(paths: string[], options?: IGherkinOptions): Readable;
export declare function fromSources(envelopes: messages.IEnvelope[], options?: IGherkinOptions): Readable;
export declare function dialects(): {
    [key: string]: Dialect;
};
declare const _default: {
    fromStream: typeof fromStream;
    fromPaths: typeof fromPaths;
    fromSources: typeof fromSources;
    dialects: typeof dialects;
    uuid: typeof uuid;
    incrementing: typeof incrementing;
};
export default _default;
